﻿Imports System.ComponentModel
Imports System.Windows
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls

Namespace WP7App
  Partial Public Class DetailsPage
	  Inherits PhoneApplicationPage
	Private _orderId As Integer
	Private _orderIndex As Integer
	Public Sub New()
	  InitializeComponent()
	  AddHandler App.ViewModel.PropertyChanged, AddressOf RefreshControls
	  AddHandler Loaded, AddressOf DetailsPage_Loaded
	End Sub

	' When page is navigated to set data context to selected item in list
	Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
	  Dim selectedIndex As String = ""
	  If NavigationContext.QueryString.TryGetValue("selectedItem", selectedIndex) Then
		_orderIndex = Integer.Parse(selectedIndex)
		DataContext = App.ViewModel.LineItems
		_orderId = (App.ViewModel.Orders(_orderIndex)).OrderId
	  End If
	End Sub

	Private Sub DetailsPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
		App.ViewModel.LoadLineItems(_orderId)

	End Sub
	Public Sub RefreshControls(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
      Dispatcher.BeginInvoke(Sub() ListTitle.Text = App.ViewModel.CurrentOrderNumber & " Items")
      Dispatcher.BeginInvoke(Sub() lstLineItems.ItemsSource = App.ViewModel.LineItems)

	End Sub
  End Class
End Namespace