﻿Imports System.ComponentModel
Imports System.Windows
Imports System.Windows.Controls
Imports Microsoft.Phone.Controls

Namespace WP7App
  Partial Public Class MainPage
	  Inherits PhoneApplicationPage
	' Constructor
	Public Sub New()
	  InitializeComponent()

	  DataContext = App.ViewModel
	  AddHandler Loaded, AddressOf MainPage_Loaded
	  AddHandler App.ViewModel.PropertyChanged, AddressOf PropertyChanged
	  AddHandler App.ViewModel.SaveStatusChanged, AddressOf SaveStatusChanged
	End Sub

	' Load data for the ViewModel Items
	Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
	  If Not App.ViewModel.IsDataLoaded Then
		App.ViewModel.LoadData()

	  End If
	End Sub


	Public Sub PropertyChanged(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
	  Dim propChanged = e.PropertyName
	  Select Case propChanged
		Case "Customer"

          Dispatcher.BeginInvoke(Sub() stackPanel1.DataContext = App.ViewModel.Customer)
          Dispatcher.BeginInvoke(Sub() lstOrders.ItemsSource = App.ViewModel.Orders)
	  End Select
	End Sub

	Public Sub SaveStatusChanged(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
	  Dim status = e.PropertyName
	  If e.PropertyName.StartsWith("Error") AndAlso (Not e.PropertyName.Contains("Invalid cross-thread")) Then
		  status = "Error"
	  End If

	  Select Case status
		Case "Saved"
          Dispatcher.BeginInvoke(Sub() SavedGrid.Visibility = System.Windows.Visibility.Visible)
		Case "Error"
          Dispatcher.BeginInvoke(Sub() savedText.Text = "Error")
          Dispatcher.BeginInvoke(Sub() SavedGrid.Visibility = System.Windows.Visibility.Visible)
	  End Select

	End Sub

	Private Sub lstOrders_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
	  ' If selected index is -1 (no selection) do nothing
	  If lstOrders.SelectedIndex = -1 Then
		Return
	  End If

	  ' Navigate to the new page
	  NavigationService.Navigate(New Uri("/DetailsPage.xaml?selectedItem=" & lstOrders.SelectedIndex, UriKind.Relative))

	  ' Reset selected index to -1 (no selection)
	  lstOrders.SelectedIndex = -1
	End Sub

	Private Sub Save_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
	  App.ViewModel.Save()
	End Sub

	Private Sub button2_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
	  savedText.Text = "Saved!"
	  SavedGrid.Visibility = Visibility.Collapsed
	End Sub
  End Class
End Namespace