﻿Imports DataLayer
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports CustomerOrder.Entities
Imports System.Data.Entity

Namespace TestProject1

  <TestClass()>
  Public Class ContextTest

    Public Sub New()
      Database.SetInitializer(New MyInitializer())
    End Sub


    <TestMethod()>
    Public Sub CustomersTest()
      Dim target = New CustomerOrderContext()

      Assert.IsNotNull(target.Customers.ToList())
    End Sub
    <TestMethod()>
    Public Sub CanInsertNewCustomerAndOrder()

      Dim db = New CustomerOrderContext()

      Dim custCount = db.Customers.Count()
      Dim orderCount = db.Orders.Count()
      Dim customer = New Customer With {.FirstName = "Julie", .LastName = "Lerman"}

      db.Customers.Add(customer)
      customer.Orders.Add(New Order With {.SalesOrderNumber = "12345", .DueDate = Date.Today + New TimeSpan(30, 0, 0, 0), .OrderDate = Date.Today})
      db.SaveChanges()

      db = New CustomerOrderContext()
      Assert.AreEqual(db.Customers.Count(), custCount + 1)
      Assert.AreEqual(db.Orders.Count(), orderCount + 1)
    End Sub
  End Class
End Namespace
